SystemOrganization addCategory: #ConfigurationOfDBXTools!

Object subclass: #ConfigurationOfDBXTools
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfDBXTools'!

!ConfigurationOfDBXTools class methodsFor: 'private' stamp: 'SantiagoBragagnolo 5/7/2011 23:22'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfDBXTools class methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/31/2011 12:18'!
ensureMetacello
        "Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
         Gofer API), then load the latest version of Metacello itself."

        Smalltalk at: #MetacelloProject ifAbsent: [ | error |
                "list of repositories to try, in case primary repository is not accessible"
                (Array 
                        with: 'http://www.squeaksource.com/MetacelloRepository' 
                        with: 'http://seaside.gemstone.com/ss/metacello') do: [:repositoryUrl |
                                ([
                                        Smalltalk at: #Gofer ifAbsent: [
                                        "Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
                                                self bootstrapPackage: 'Gofer-Core-lr.115' from: repositoryUrl ].
                                        Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
                                                gofer := goferClass new
                                                        url: repositoryUrl;
                                                        yourself.
                                                [ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
                                                gofer load ]]
                                                        on: Error
                                                        do: [ :ex |
                                                                error := ex.
                                                                Transcript 
                                                                        cr; 
                                                                        show: 'failed ensureMetacello: ';
                                                                        show: ex description printString;
                                                                        show: '...retrying'.
                                                                "try again"
                                                                ex return: nil ]) ~~ nil
                                        ifTrue: [
                                                "load 'default' group of Metacello"
                                                (Smalltalk at: #ConfigurationOfMetacello) perform: #load.
                                                ^self ]].
                "shouldn't get here unless the load failed ... throw an error"
                self error: 'retry with alternate repository failed: ', error description printString ]! !

!ConfigurationOfDBXTools class methodsFor: 'metacello tool support' stamp: 'SantiagoBragagnolo 5/7/2011 23:22'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfDBXTools class methodsFor: 'metacello tool support' stamp: 'SantiagoBragagnolo 5/7/2011 23:22'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfDBXTools class methodsFor: 'loading' stamp: 'SantiagoBragagnolo 5/7/2011 23:22'!
load
	^self project latestVersion load! !

!ConfigurationOfDBXTools class methodsFor: 'loading' stamp: 'GuillermoPolito 12/20/2011 19:20'!
loadBleedingEdge
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfDBXTools class methodsFor: 'metacello tool support' stamp: 'SantiagoBragagnolo 5/7/2011 23:22'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfDBXTools class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/7/2011 23:22'!
project

	^self new project! !

!ConfigurationOfDBXTools methodsFor: 'baselines' stamp: 'GuillermoPolito 12/23/2011 20:23'!
baseline10: spec
    <version: '1.0-baseline'>
    
    spec for: #squeakCommon do: [
		spec blessing: #baseline.
		spec description: 'FFI-Examples removed from repository!!'.
		spec repository: 'http://www.squeaksource.org/DBXTalk'.

		spec package: 'DBXDatabaseModel' with: [ spec requires: 'OpenDBXDriver' ].
		spec package: 'DBXDatabaseModelTests' with: [ spec requires: #( 'DBXDatabaseModel' )].
		
		spec package: 'DBXTools-DescriptionsTests' with: [ spec requires: #('DBXTools-Descriptions') ].
		spec package: 'DBXTools-Descriptions' with:[ spec requires: #('Magritte' 'Glorp' 'AllDatabaseModel' ) ].
		
		spec project: 'Glorp' with: [ spec
			className: 'ConfigurationOfGlorpDBX';
			file: 'ConfigurationOfGlorpDBX'.
		].
	
		spec project: 'OpenDBXDriver' with: [ spec
			className: 'ConfigurationOfOpenDBXDriver';
			file: 'ConfigurationOfOpenDBXDriver'.
		].

		spec project: 'Magritte' with: [ spec
			className: 'ConfigurationOfMagritte';
			file: 'ConfigurationOfMagritte';
			repository: 'http://www.squeaksource.com/MetacelloRepository'.
		].

		spec group: 'Tests' with: #( 'DBXDatabaseModelTests' 'DBXTools-DescriptionsTests' ).
		spec group: 'Core' with:#('DBXDatabaseModel' 'DBXTools-Descriptions' ).
		spec group: 'Phoseydon' with: #( 'DBXTools-Descriptions' 'DBXTools-DescriptionsTests' ).
		spec group: 'AllDatabaseModel' with: #( 'DBXDatabaseModel' 'DBXDatabaseModelTests' ).
		spec group: 'default' with: #( 'Core' 'Tests' ).
	]! !

!ConfigurationOfDBXTools methodsFor: 'baselines' stamp: 'GuillermoPolito 1/5/2012 23:11'!
baseline11: spec
    <version: '1.1-baseline'>
    
    spec for: #squeakCommon do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.org/DBXTalk'.

		spec package: 'DBXDatabaseModel' with: [ spec requires: 'OpenDBXDriver' ].
		spec package: 'DBXDatabaseModelTests' with: [ spec requires: #( 'DBXDatabaseModel' )].
		
		spec package: 'DBXTools-DescriptionsTests' with: [ spec requires: #('DBXTools-Descriptions') ].
		spec package: 'DBXTools-Descriptions' with:[ spec requires: #('Magritte' 'Glorp' 'DBXDatabaseModel' ) ].
		
		spec project: 'Glorp' with: [ spec
			className: 'ConfigurationOfGlorpDBX';
			file: 'ConfigurationOfGlorpDBX'.
		].
	
		spec project: 'OpenDBXDriver' with: [ spec
			className: 'ConfigurationOfOpenDBXDriver';
			file: 'ConfigurationOfOpenDBXDriver'.
		].

		spec project: 'DBXBrowser' with: [ spec
			className: 'ConfigurationOfDBXBrowser';
			file: 'ConfigurationOfDBXBrowser';
			repository: 'http://www.squeaksource.com/DBXTalk'.
		].

		spec project: 'Magritte' with: [ spec
			className: 'ConfigurationOfMagritte';
			file: 'ConfigurationOfMagritte';
			repository: 'http://www.squeaksource.com/MetacelloRepository'.
		].

		spec group: 'Tests' with: #( 'DBXDatabaseModelTests' 'DBXTools-DescriptionsTests' ).
		spec group: 'Core' with:#('DBXDatabaseModel' 'DBXTools-Descriptions' ).
		spec group: 'Neptuno' with: #( 'DBXBrowser' ).
		spec group: 'Phoseydon' with: #( 'DBXTools-Descriptions' 'DBXTools-DescriptionsTests' ).
		spec group: 'AllDatabaseModel' with: #( 'DBXDatabaseModel' 'DBXDatabaseModelTests' ).
		spec group: 'default' with: #( 'Core' 'Tests' ).
		spec group: 'DeveloperGroup' with: #( 'Core' 'Tests' 'Phoseydon' 'AllDatabaseModel' ).
	]! !

!ConfigurationOfDBXTools methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/7/2011 23:22'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfDBXTools methodsFor: 'versions' stamp: 'GuillermoPolito 1/5/2012 23:11'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'common' version: '0.2'. 
! !

!ConfigurationOfDBXTools methodsFor: 'versions' stamp: 'GuillermoPolito 12/23/2011 19:47'!
version01: spec
	<version: '0.1' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #beta.
		spec project: 'Magritte' with: '1.2.1.4'.
		
		spec project: 'Glorp' with: '2.4'.
		
		spec package: 'DBXDatabaseModel' with: 'DBXDatabaseModel-GuillermoPolito.26'.
		spec package: 'DBXDatabaseModelTests' with: 'DBXDatabaseModelTests-GuillermoPolito.10'.
		spec package: 'DBXTools-DescriptionsTests' with: 'DBXTools-Descriptions-GuillermoPolito.60'.
		spec package: 'DBXTools-Descriptions' with: 'DBXTools-DescriptionsTests-GuillermoPolito.28'.
	]! !

!ConfigurationOfDBXTools methodsFor: 'versions' stamp: 'GuillermoPolito 1/5/2012 23:10'!
version02: spec
	<version: '0.2' imports: #('1.1-baseline')>
	
	spec for: #common do: [
		spec blessing: #beta2.
		spec project: 'Magritte' with: '1.2.1.4'.
		
		spec project: 'Glorp' with: '2.4'.
		spec project: 'DBXBrowser' with: #bleedingEdge.
		
		spec package: 'DBXDatabaseModel' with: 'DBXDatabaseModel-GuillermoPolito.28'.
		spec package: 'DBXDatabaseModelTests' with: 'DBXDatabaseModelTests-GuillermoPolito.10'.
		spec package: 'DBXTools-DescriptionsTests' with: 'DBXTools-DescriptionsTests-GuillermoPolito.39'.
		spec package: 'DBXTools-Descriptions' with: 'DBXTools-Descriptions-GuillermoPolito.71'.
	]! !
